//File : TreeView.js
//Author : Tone koda 
//e-mail: tone.skoda@siol.net
//www10.brinkster.com/tskoda
//Created : 9. november 2000
//Updated: 9. November 2001
//Purpose : TreeView with JavaScript for HTML sites.
//
//warning:	You mustn't have any object 
//			on your html page whose ID STARTS with 
//			TsTreeId value (look few lines down
//			to see what this value is exactly).
//			For now it only supports one tree on one site.

var AllMainObjects=new Array()		//here save every main object created with makeTreeObj
var TsTreeId="TSTreeView"			//id in htmls page added before each item, together they generate item+number (eg.: item33)
var TsItemIds=TsTreeId+"_item_"		//id in htmls page added before each item, together they generate item+number (eg.: item33)
var TSCurImageIds=TsTreeId+"_CurImage_"
var TSHorLineIds=TsTreeId+"_HorLine_"
var TSVerLineIds=TsTreeId+"_VerLine_"
var TSPlusMinusIds=TsTreeId+"_PlusMinus_"
var vbCrLf=""
var strResult=""

// customize these:
var DotImage='images/dot.jpg'
var PlusImage='images/plus.jpg'
var MinusImage='images/minus.jpg'
var ImageToTextSpacing=3	//space between item text and image
//var ItemTopSpacing=5		//vertical space between two items

// Browsers:
var I_E; // Internet Explorer.
var N_S; // Netscape Navigator, < 6.
var N_S_6; // Netscape 6.


// Debugging function.
// Shows properties of object in alert box.
function alertObjProp(obj)
{
	var s=""	
	for(var prop in obj)	
	{
		s+=prop + '=' +obj[prop]+ '\n' 
	}
	
	alert(s)
}

// Debugging function.
// Show properties of object in new window.
function popObjProp(obj)
{
	var s=""
	for(var prop in obj)	
	{
		s+=prop + '=' +obj[prop]+ '\n<br>' 
	}

	s+='\n<br><br><br>----------------------------------------'
	
	newWin=open('','newWin');
	newWin.document.write(s)
}

//moves object with id which you can set to any object
//example: <div id='myid'>text has id myid</div>
function moveObject(id,left,top)
{
//popObjProp (document.documentElement)

	if(N_S)
	{	
		id.left=left
		id.top=top
	}
	else if (I_E)
	{	
		id.style.left=left; // THIS LINE IS CAUSING NS 6.0 	ERROR!
		id.style.top=top;		
	}
}

//shows object with id which you can set to any object
//example: <div id='myid'>text has id myid</div>
function showObject(id)
{
	if(N_S)
	{
		id.visibility='show'
	}
	else if (I_E)
	{
		id.style.visibility='visible'		
	}
}

//writes one item to document, this only happns
//once when you insert item
function writeOneItem(item,toolTip)
{	
	if(I_E) //explorer
	{
		//s='<a href="javascript:" id='+TsItemIds+item.id
		s='\n\n<div id='+TsItemIds+item.id
		s+=' NOWRAP'
        s+=' onMouseOver="onItemMouseOver (this.id);return true;"'		
		s+=' class='+TsTreeId+'ItemClass'
		if(toolTip)
		{
			s+=' title="'+toolTip+'"'
		}
		else
		{
			if (item.hyperLink)
			{
				s+=' title="'+item.hyperLink+'"'
			}
			else
			{
				s+=' title="'+item.text+'"'
			}
		}
	//	var red="'red'"
	//	s+=' onMousedown="this.style.backgroundColor='+red+'"'
		//s+=(' ONCLICK=onItemClick('+item.id+','+this.id+')')
		s+=' \nstyle="position: absolute;'
		s+=' \nfont-size:' + this.itemHei + ';'
		s+=' filter:alpha(opacity=90)'
		//s+=' BACKGROUND-COLOR:'+this.bkColor+';'
		//s+=' COLOR: '+this.textColor+';'		
		s+=' cursor:hand;'
		//s+=' TEXT-ALIGN: top;'
		s+=' visibility:hidden" >'	

		/*item image*/				
		s+='<a href=javascript:this.onImgClick('+item.id+')>'
		s+='<img id='+TSCurImageIds+item.id
		s+=' align=center border=0 hspace='+ImageToTextSpacing+' src="'	
		s+=item.image.src
		if(toolTip)
		{
			s+='" alt="'+toolTip+'"'
		}
		else
		{
			s+='" alt="'+item.text+'"'
		}	
		s+='">'
		s+='</a>'
		
		//popObjProp (item)

		if (item.preText)
		{
			s += '\n' + item.preText
		}

		s+='\n<a href=javascript:this.onItemTextClick('+ item.id +') '
		if (item.hyperLink)
		{
			s += 'class='+TsTreeId+'HyperLinkClass>'
		}
		else
		{
			s += 'class='+TsTreeId+'LinkClass>'
		}
		
		//s+='\n<a href="#" class='+TsTreeId+'LinkClass>'
				
		s+='\n' + item.text
		s+='</a>'
		if (item.afterText)
		{
			s += '\n' + item.afterText
		}
		s+='\n</div>'

		if(this.showPlusAndLines)
		{

			/*horizontal line*/
			s+=' <img id='+TSHorLineIds+item.id
			s+=' src="'+DotImage+'"'
			s+=' style="position: absolute;'
			s+=' width:'+this.toRight+';'
			s+=' height:'+1+';'
			s+=' visibility:hidden'
			s+=' ">'

			/*vertical line*/
			s+=' <img id='+TSVerLineIds+item.id
			s+=' src="'+DotImage+'"'
			s+=' style="position: absolute;'
			s+=' width:1;'	
			s+=' visibility:hidden'
			s+=' ">'

			/*plus or minus image*/
			s+=' <img id='+TSPlusMinusIds+item.id
			//s+=' src="'+PlusImage+'"'
			s+=' style="position: absolute;'
			s+=' visibility:hidden'
			s+=' ">'
		}//if show plus and lines

	}//explorer
	
	else if (N_S) //netscape
	{
		s='\n\n<TD NOWRAP>'
		s+='\n<layer name="'+TsItemIds+item.id + '"'
		s+=' NOWRAP'
        s+=' onMouseOver="onItemMouseOver (this.id);return true;"'
		//s+=' class='+TsTreeId+'ItemClass'
		if(toolTip)
		{
			s+=' title="'+toolTip+'"'
		}
		else
		{
			if (item.hyperLink)
			{
				s+=' title="'+item.hyperLink+'"'
			}
			else
			{
				s+=' title="'+item.text+'"'
			}			
		}
		s+=' \nposition="absolute"'
		s+=' \nfont-size=' + this.itemHei 
		s+=' visibility=hide>'
		/*item image*/
		s+='\n<a href=javascript:this.onImgClick('+item.id+')>'		
		s+='<img name='+TSCurImageIds+item.id
		s+=' border=0 hspace='+ImageToTextSpacing+' src="'	
		s+=item.image.src
		if(toolTip)
		{
			s+='" alt="'+toolTip+'"'
		}
		else
		{
			s+='" alt="'+item.text+'"'
		}	
		s+='">'
		s+='</a>'
		//TsItemIds+item.id
		if (item.preText)
		{
			s += '\n' + item.preText
		}
		s+='\n<a href=javascript:this.onItemTextClick('+ item.id +') '		
		if (item.hyperLink)
		{
			s += 'class='+TsTreeId+'HyperLinkClass>'
		}
		else
		{
			s += 'class='+TsTreeId+'LinkClass>'
		}
		s+='\n' + item.text		
		s+='\n</a>'
		if (item.afterText)
		{
			s += '\n' + item.afterText
		}
		s+='\n</layer>'		
		s+='\n</TD>'


		if(this.showPlusAndLines)
		{
			/*horizontal line*/
			s+=' <img id='+TSHorLineIds+item.id
			s+=' src="'+DotImage+'"'
			s+=' style="position: absolute;'
			s+=' width:'+this.toRight+';'
			s+=' height:'+1+';'
			s+=' visibility:hidden'
			s+=' ">'

			/*vertical line*/
			s+=' <img id='+TSVerLineIds+item.id
			s+=' src="'+DotImage+'"'
			s+=' style="position: absolute;'
			s+=' width:1;'	
			s+=' visibility:hidden'
			s+=' ">'

			/*plus or minus image*/
			s+=' <img id='+TSPlusMinusIds+item.id
			//s+=' src="'+PlusImage+'"'
			s+=' style="position: absolute;'
			s+=' visibility:hidden'
			s+=' ">'
		}//if show plus and lines

	}//netscape

	document.write(s)
}

function displayOneItem(x,y,item)
{
	var itemhei=this.itemHei
	var halfhei=this.itemHei/2
	var htmid=item.obj
	var itemid=item.id

	moveObject(htmid,x,y)	
	showObject(htmid)

	//this below works fine
	//htmid.style.fontSize=this.itemHei-(ItemTopSpacing/2)	

//	these two below work but without them images look better
//	eval(TSCurImageIds+itemid).width=eval(TSCurImageIds+itemid).width*((this.itemHei-(ItemTopSpacing/2))/eval(TSCurImageIds+itemid).height)
//	eval(TSCurImageIds+itemid).height=this.itemHei-(ItemTopSpacing/2)		
	
	if(item.exp && item.children.length)
	{
		if(I_E)
		{
			document.images[TSCurImageIds+itemid].src=item.selImage.src
		}
		else if(N_S)
		{
			if (N_S_6)
			{			
				//TODO
				//alertObjProp (document.images[TSCurImageIds+itemid])
				//document.images[TSCurImageIds+itemid].src=item.selImage.src
			}
			else
			{
				if(this.parentLayer)
				{
						this.parentLayer.document.layers[TsItemIds+itemid].document.images[TSCurImageIds+itemid].src=item.selImage.src
				}
				else
				{
					document.layers[TsItemIds+itemid].document.images[TSCurImageIds+itemid].src=item.selImage.src
				}
			}
		}
		
		if(this.showPlusAndLines)
		{
			document.images[TSPlusMinusIds+itemid].src=MinusImage
		}
	}
	else
	{
		if(I_E)
		{
			document.images[TSCurImageIds+itemid].src=item.image.src
		}
		else if(N_S)
		{
			if(this.parentLayer)
			{
				this.parentLayer.document.layers[TsItemIds+itemid].document.images[TSCurImageIds+itemid].src=item.image.src
			}
			else
			{
				document.layers[TsItemIds+itemid].document.images[TSCurImageIds+itemid].src=item.image.src
			}
		}
		

		if(item.children.length && item.exp==false)
		{		
			if(this.showPlusAndLines)
			{
				if(I_E)
				{
					document.images[TSPlusMinusIds+itemid].src=PlusImage
				}
				else if(N_S)
				{
					document.layers[TsItemIds+itemid].document.images[TSPlusMinusIds+itemid].src=PlusImage
				}
				
			}
		}
	}
	
	if(item.parent)
	{
		
		if (this.showPlusAndLines)
		{
			/*set horizontal line position*/
			var tmpobj1=item.imgHorObj.style
			tmpobj1.top=y+(this.itemHei/2)
			tmpobj1.left=x-this.toRight+(this.itemHei/2)
			tmpobj1.width=this.toRight-(this.itemHei/2)
			showObject(item.imgHorObj)

			/*set plus or minus image position*/		
			if(item.children.length)
			{
				var obj=item.imgPlusMinusObj
				var imgWid=obj.width
				var imgHei=obj.height
				var tmpobj1=obj.style
				tmpobj1.top=y+(this.itemHei/2)-(imgWid/2)+1
				tmpobj1.left=x-this.toRight+(this.itemHei/2)-(imgHei/2)+1
				showObject(obj)
			}
		}
	}
}

//displays all items
//returns: height of displayed tree
// GLOBAL
function displayItems()
{
	var x=this.x
	var y=this.y
	var ty=y
	var children=root.children	
	var i=0
	var child
	var parent,grandParent
	var where=new Array()		//where we are, indexes of last item before displying it's children
	var lastChild=new Array()	//in connection with 'where' array, what was last child displayed before displaying it's subitems
	var lastChildY=new Array()	//in connection with 'where' array, what was last child y postion (to draw vertical line)

	//display root	
	this.displayOneItem(x,y,root)	
	ty+=this.itemHei + this.vertSpacing
	x+=this.toRight
		
	if(root.exp==false || root.children.length==0)
	{
		this.numVisItems=ty
		return ty
	}
	
	for(;;)
	{	
		if(child)
		{
			parent=child.parent	
		}

		if(i>=children.length)
		{
			
			if(child.parent)
			{
				if(parent)
				{
					do
					{						
						var theLastChild=children[i-1]
						var theParent=theLastChild.parent						

						if(this.showPlusAndLines)
						{							
							/*set vertical line position*/
							//if(theParent)
							{
								var pobjs=theParent.obj.style
								var vobj=theParent.imgVerObj

								var parTop=parseInt(pobjs.top)
								var theLastChildTop=parseInt(theLastChild.obj.style.top)
								
								var vobjs=vobj.style
								vobjs.top=parTop+(this.itemHei)
								vobjs.left=parseInt(pobjs.left)+(this.itemHei/2)
								vobjs.height=theLastChildTop-parTop-(this.itemHei/2)
								showObject(vobj)
							}
						
						}


						if((lastChild.length)<=0)
						{
							this.numVisItems=ty
							return ty
						}

						x-=this.toRight
						var lChild=lastChild[lastChild.length-1]
						parent=lChild.parent
						if(parent==0)
						{
							this.numVisItems=ty
							return ty
						}
						//grandParent=parent.parent
						/*if(grandParent==0)
						{
							this.numVisItems=ty
							return ty
						}*/
						children=parent.children
						i=where[where.length-1]+1

						where=where.slice(0,-1)
						lastChild=lastChild.slice(0,-1)
						lastChildY=lastChildY.slice(0,-1)
												
						if(i<children.length)
						{
							break
						}
						
					}while(1)

				}
				else{break}
			}
			else{break}
		}		

		child=children[i]

		this.displayOneItem(x,ty,child)		
		ty=ty+this.itemHei +  this.vertSpacing

		//has this item any sub items?
		//display them if yes and expanded
		if(child.children.length && child.exp)
		{
			x+=this.toRight
			children=children[i].children
			where[where.length]=i
			lastChild[lastChild.length]=child
			lastChildY[lastChildY.length]=ty
			i=-1
		}
		
		i++
	}

	this.numVisItems=ty
	return ty
}

//hides *all* items, including root
//to do something here for better speed?
// GLOBAL
function hideAllItems()
{
	var len=this.allItems.length
	
	if(I_E)
	{
		if(this.showPlusAndLines)
		{
			for(i=0;i<len;i++)
			{
				var item=this.allItems[i]
				item.obj.style.visibility='hidden'
				

				item.imgHorObj.style.visibility='hidden'
				item.imgVerObj.style.visibility='hidden'
				item.imgPlusMinusObj.style.visibility='hidden'
			}
		}
		else
		{
			for(i=0;i<len;i++)
			{
				var item=this.allItems[i]
				item.obj.style.visibility='hidden'
			}
		}
	}//IE
	else if(N_S)
	{
		if(this.showPlusAndLines)
		{
			for(i=0;i<len;i++)
			{
				var item=this.allItems[i]
				item.obj.visibility='hide'
				

				item.imgHorObj.visibility='hide'
				item.imgVerObj.visibility='hide'
				item.imgPlusMinusObj.visibility='hide'
			}
		}
		else
		{
			for(i=0;i<len;i++)
			{
				var item=this.allItems[i]
				item.obj.visibility='hide'
			}
		}
	}//NS
}

//with this function you define
//	which function(in your document)
//	is going to be executed when item  text is clicked
//arg. func: example: "onItemClickProc"
//first argument 'item' with onItemClickProc
//is item clicked (you can get all of it's properties)
// GLOBAL
function setOnItemClickProc(func)
{
	this.onItemClickProc=func
}

//this function is executed when item image is clikced
//arg. func: example: "onItemIMGClickProc"
//first argument 'item' with onItemClickProc
//is item clicked (you can get all of it's properties)
// GLOBAL
function setOnItemIMGClickProc(func)
{
	this.onItemIMGClickProc=func
}

//sets selected item
function setSelItem(id)
{
	this.selItem=id

	if(I_E)
	{
		tmpobj = this.allItems[id].obj.style
		tmpobj.background=this.selectedBkColor
	}
	else if(N_S)
	{
		tmpobj = this.allItems[id].obj
		tmpobj.bgColor=this.selectedBkColor
	}
	//tmpobj.color=this.selectedTextColor	
}

//you have to call this function only for netscape
//and if tree is under any parent layer(s), other wise
//you don't need to call it
//
//arg. parentLayer: parnet layer name
//
//example:
//<layer name="parLyr">
//tree...
//</layer>
//tree.setParentLayer("parLyr")
// GLOBAL
function setParentLayer(parentLayer)
{
	this.parentLayer=document[parentLayer]
	//alertObjProp(document[parentLayer])
}

//arg. parentLayerObj: e.g: eval("layerName")
// GLOBAL
function setParentLayerObj(parentLayerObj)
{
	this.parentLayer=parentLayerObj
}

function onItemMouseOver (HTMLid)
{
	id=HTMLid.slice(TsItemIds.length,HTMLid.length)	
	//var htmidFirstPart=htmid.slice(0,TsItemIds.length)	
	the_item=FirstMainObj.allItems[id]
	if (the_item.hyperLink)
	{
		window.status = the_item.hyperLink;
	}
	else
	{
		if (the_item.toolTip)
		{
			window.status = the_item.toolTip;
		}
		else
		{
			window.status = the_item.text;
		}
	}
	return true;
}

/*item image clicked*/
function onImgClick(id)
{	
	//EXPAND SUB ITEMS:
	tmpitem=FirstMainObj.allItems[id]	
	
	if(tmpitem.exp)
	{
		tmpitem.exp=false
	}
	else
	{
		tmpitem.exp=true
	}				

	if(tmpitem.children.length)
	{	
		FirstMainObj.hideAllItems()
		FirstMainObj.displayItems()
	}	

	//EXPAND SUB ITEMS.	

	//execute outer function
	if(FirstMainObj.onItemClickProc)
	{
		eval(FirstMainObj.onItemIMGClickProc+'(tmpitem)')
	}
}

//when item text is clicked
function onItemTextClick(id)
{		
	tmpitem=FirstMainObj.allItems[id]

    if (FirstMainObj.expandOnTextClick == 1)
    {
		if (tmpitem.hyperLink == false || (tmpitem.hyperLink != false && FirstMainObj.expandHyperLinks == true))
		{
			//EXPAND SUB ITEMS:	    
			
			if(tmpitem.exp)
			{
				tmpitem.exp=false
			}
			else
			{
				tmpitem.exp=true
			}				

			if(tmpitem.children.length)
			{
				FirstMainObj.hideAllItems()
				FirstMainObj.displayItems()
			}
		}

	    //EXPAND SUB ITEMS.	
    }


	if (tmpitem.hyperLink)
	{		
		if (tmpitem.hyperLinkTarget)	
		{ // open in different window
			eval(tmpitem.hyperLinkTarget).location.href = tmpitem.hyperLink
		}
		else
		{
			if (FirstMainObj.targetWindow)
			{ // open in different window
				eval(FirstMainObj.targetWindow).location.href = tmpitem.hyperLink
			}
			else
			{ // open in same window
				location.href = tmpitem.hyperLink
			}
		}
	}

	if(I_E)
	{
		//SET TEXT COLORS:

		if(FirstMainObj.selItem!=-1)
		{	
			tmpobj=FirstMainObj.allItems[FirstMainObj.selItem].obj.style
			tmpobj.color=FirstMainObj.textColor
						
			tmpobj.background=0; // FirstMainObj.bkColor (9. November 2001, 23:50)
		}				

		FirstMainObj.selItem=id

		if(I_E)
		{
			tmpobj = FirstMainObj.allItems[id].obj.style
		}
		else if(N_S)
		{
			tmpobj = FirstMainObj.allItems[id].obj
		}		
		tmpobj.color=FirstMainObj.selectedBkColor
				
		tmpobj.background=FirstMainObj.selectedBkColor

		//SET TEXT COLORS.
				
		//execute outer function
		if(FirstMainObj.onItemClickProc)
		{
			eval(FirstMainObj.onItemClickProc+'(tmpitem)')
		}
	}//IE
	
	else if(N_S)
	{

		//SET TEXT COLORS:

		if(FirstMainObj.selItem!=-1)
		{
			tmpobj=FirstMainObj.allItems[FirstMainObj.selItem].obj
			tmpobj.color=FirstMainObj.textColor
			
			//this below works
			tmpobj.bgColor=FirstMainObj.bkColor
		}				

		FirstMainObj.selItem=id
		tmpobj = FirstMainObj.allItems[id].obj
		
		//alertObjProp(tmpobj)
		//tmpobj.fgColor=FirstMainObj.selectedTextColor
		tmpobj.bgColor=FirstMainObj.selectedBkColor
		
		//alertObjProp(tmpobj.document.links)

		//SET TEXT COLORS.

				
		//execute outer function
		if(FirstMainObj.onItemClickProc)
		{
			eval(FirstMainObj.onItemClickProc+'(tmpitem)')
		}
	}//NS
}

// Expands all items.
// GLOBAL
function expandAll ()
{
	for(i=this.allItems.length - 1;i>=0;i--)
	{
		this.allItems[i].exp = true
	}
	this.displayItems ()
}

// Collapses all items.
// GLOBAL
function collapseAll ()
{	
	for(i=this.allItems.length - 1;i>=0;i--)
	{
		this.allItems[i].exp = false
	}	
	this.hideAllItems ()
	this.displayItems ()
}

//data has this format (not sure if all listed here):
// 
// item text, label
// item parent, for root 0, object which has same sturucture as this
// item children, all children here
// item closedImage
// item openedImage
// item exp, is item expanded, [true,false]
// item id, id is from 0 (root) till total number of items(all items)
// item htmid, html id
// item obj, text object got with eval() function
// item imgObj, item image object got with eval() function
//
////next 3 only if defined showPlusAndLines
//		item imgHorObj, item horiz. image object got with eval() function
//		item imgVerObj, item vert. image object got with eval() function
//		item imgPlusMinusObj, item plus/minus. image object got with eval() function
function makeItemObj(parent,text,image,selImage,exp,id, hyperLink, hyperLinkTarget, toolTip, preText, afterText, TipoElemento)
{
	this.preText = preText;
	this.afterText = afterText;	
	this.text=text
	this.hyperLink = hyperLink
	this.hyperLinkTarget = hyperLinkTarget
	this.children=new Array()	
	this.toolTip = toolTip	
	this.TipoElemento = TipoElemento	
	
	imgsel=new Image()
	imgsel.src=selImage
	this.selImage=imgsel
	
	img=new Image()
	img.src=image
	this.image=img

	this.exp=exp
	this.id=id
	
	if(parent) //this is child item
	{
		this.parent=parent
		parent.children[parent.children.length]=this		
	}
	//else: This can only be ROOT item	
			
	return this
}

//--------------------------------------------------------------------------
//Inserts one item into treeview.
//arg. parent: if 0 then creating root
//	else it's under which parent we will insert subtreeview
//arg. text: item text
//arg. closedimage: image(icon) on the left side when item is closed.
//arg. openedImage: image(icon) on the left side when item open.
//arg. hyperLink: hyper link to go to when item is clicked
//arg. hyperLinkTarget: window in which hyperlink should open
//arg. preText: text which is inserted before item text and is not part of hyperlink
//arg. afterText: text which is inserted after item text and is not part of hyperlink
//arg. TipoElemento: Tipo del elemento del rbol
// GLOBAL
//--------------------------------------------------------------------------
function insertItem(parent,text,closedimage,openedImage,exp,toolTip, hyperLink, hyperLinkTarget, preText, afterText, TipoElemento)
{
	tmp=new makeItemObj(parent,text,closedimage,openedImage,exp,this.allItems.length, hyperLink, hyperLinkTarget, toolTip, preText, afterText, TipoElemento)
	if(parent==0) //root
	{
		root=tmp
	}
	this.allItems[this.allItems.length]=tmp

	this.writeOneItem(tmp,toolTip)

	if(I_E)
	{
		// tmp.obj=eval(TsItemIds+tmp.id)
		// tmp.imgObj=eval(TSCurImageIds+tmp.id)
        // Contributed by Cobus Roets for Netscape 6.
        tmp.obj=document.getElementById(TsItemIds+tmp.id)
        tmp.imgObj=document.getElementById(TSCurImageIds+tmp.id)

	}
	else if (N_S)
	{
		if(this.parentLayer)
		{
			
			tmp.obj=this.parentLayer.document.layers[TsItemIds+tmp.id]
			tmp.imgObj=this.parentLayer.document.layers[TSCurImageIds+tmp.id]
		}
		else
		{
			tmp.obj=document.layers[TsItemIds+tmp.id]
			tmp.imgObj=document.layers[TSCurImageIds+tmp.id]
		}		
	}

	if(this.showPlusAndLines)
	{
		tmp.imgHorObj=eval(TSHorLineIds+tmp.id)
		tmp.imgVerObj=eval(TSVerLineIds+tmp.id)
		tmp.imgPlusMinusObj=eval(TSPlusMinusIds+tmp.id)		
	}	
		
	return tmp
}

// Put this function before you start inserting items.
// GLOBAL
function start ()
{
	if (N_S)
	{
		document.writeln ('<TABLE>')
	}
}

// Put this function after you have inserted all items.
// GLOBAL
function end ()
{
	if (N_S)
	{
		document.writeln ('</TABLE>')
	}
}

//---------------------------------------------------------------------------
// Main initialization function of this file.
// Put this function in head <head>in here</head> of your site, so that tree will work with Netscape Navigator.
//---------------------------------------------------------------------------
function makeTreeObj(name, // 1, just a dummy (unique) name
    x,  // 2, left position of tree
    y,  // 3, top position of tree
    itemHei,  // 4, height of items
    vertSpacing,  // 5, Vertical spacing between items.
    toRight,  // 6, How many units to right each subitem is displayed from its parent
    textColor,  // 7, color of text
    bkColor,  // 8, background color of items, not the whole tree
    selectedBkColor,  // 9, Color of item background when it's selected.
    linkTextColor,  // 10, Text color of hyper link items.
    showPlusAndLines,  // 11, if true then plus/minus image and lines are drawn, which slows down the whole thing a lot
    expandOnTextClick,  // 12, if 1 then item is expanded or collapsed when image text is clicked (except if item has no subitems).
	expandHyperLinks, // 13, if true then if text of item is clicked and that item is hyperlink, then
					// the item is expanded, if false it's not expanded.
	targetWindow, // 14, location in which hyperlinks of items open. If item has its own target it overrides this one.
				//this should be string, example: "top.frames.yourFrameName"
				// it can also be 0, then hyperlinks are open in same window    
	fuente //15, fuente del texto.
    )
{
	N_S_6 = document.documentElement // NS 6.0
	I_E = document.all // general Internet Explorer
	N_S = (document.layers) && ! I_E // Netscape Navigator 4.51
    
	if(!I_E && !N_S)
	{
        // Detecting Netscape 6 browser was contributed by Cobus Roets.
        if(N_S_6)
        {
            // I guess Netscape 6 is very similar (same!) to Internet Explorer.
            N_S_6 = null
            I_E = true
        }
        else
        {
		    alert("JavaScript Treeview on this site won't work correctly in your browser. Get Internet Explorer (version 5.0 or 6.0) or Netscape Navigator (version 4.51).");
        }
	}

	/*document.onmousedown= onMouseDown
	if(N_S)
	{
		//document.captureEvents(Event.MOUSEMOVE);
		document.captureEvents(Event.MOUSEDOWN);
		//document.captureEvents(Event.CLICK);
		//document.onmouseover = onMouseDown
	}*/

	if (N_S)
	{ // Transparent colors
		if (bkColor == "")
			bkColor = null
		if (textColor == "")
			textColor = null
		if (selectedBkColor == "")
			selectedBkColor = null
		if (linkTextColor == "")
			linkTextColor = null
	}

	s = '\n<style type="'+'text/css'+'">'	
	s+= '\n.'+TsTreeId+'ItemClass{position:absolute;cursor:hand; background: ' + bkColor + ' }'
	if (fuente != "")
		s+= '\n.'+TsTreeId+'LinkClass{font-family: ' + fuente + '; color: ' + textColor + '; text-decoration: none;}'
	else
		s+= '\n.'+TsTreeId+'LinkClass{color: ' + textColor + ';text-decoration: none;}'
	s+= '\n.'+TsTreeId+'HyperLinkClass{color: ' + linkTextColor + ';text-decoration: none;}'
	s+= '\n</style>'
	document.write(s)
    
	this.start = start // function
	this.end = end // function
	this.targetWindow = targetWindow
	this.expandHyperLinks = expandHyperLinks
	this.expandAll = expandAll	//function
	this.collapseAll = collapseAll	//function	
	this.expandOnTextClick = expandOnTextClick
	this.linkTextColor = linkTextColor
	this.selectedBkColor = selectedBkColor
	this.vertSpacing = vertSpacing
	this.name=name
	this.insertItem=insertItem
	this.displayItems=displayItems	
	var tmp
	var root
	this.itemHei=itemHei;
	this.x=x
	this.y=y
	this.toRight=toRight	
	this.displayOneItem=displayOneItem
	this.allItems=new Array()	//all items are saved here(their pointers i hope)
	this.id=AllMainObjects.length
	this.hideAllItems=hideAllItems
	this.selItem=-1 //selected item's ID!
	this.textColor=textColor
	this.fuente=fuente
	this.bkColor=bkColor
	this.writeOneItem=writeOneItem
	this.hooveredItem=-1	
	this.showPlusAndLines=showPlusAndLines
	this.setOnItemClickProc=setOnItemClickProc
	this.onItemClickProc=0	
	this.onItemIMGClickProc=0
	this.setSelItem=setSelItem
	this.setOnItemIMGClickProc=setOnItemIMGClickProc
	this.onImgClick=onImgClick
	this.onItemTextClick=onItemTextClick

	this.numVisItems=0	//number of visible items

	if(N_S)
	{
		this.setParentLayer=setParentLayer
		this.parentLayer=0
		this.setParentLayerObj=setParentLayerObj
	}
	
	AllMainObjects[AllMainObjects.length]=this
	FirstMainObj=this	

	if(showPlusAndLines)
	{
		img1=new Image()
		img1.src=DotImage
		img2=new Image()
		img2.src=PlusImage
		img3=new Image()
		img3.src=MinusImage	
	}
	
	return this
}